! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
! #|  PMF via Warshel's mapping potential framework                  |#
! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#

   subroutine awarshel

   implicit none

!  +---------------------------------------------------------------+
!  |  Generate the mapping potential data                          |
!  +---------------------------------------------------------------+

   call gen_map_pot

!  +---------------------------------------------------------------+
!  |  Check reconstructed data against those output from Amber     |
!  +---------------------------------------------------------------+

!   call chk_mapdata

!  +---------------------------------------------------------------+
!  |  Prune data                                                   |
!  +---------------------------------------------------------------+

   call prune_map_pot 

!  +---------------------------------------------------------------+
!  |  Compute relative FE constants between mapping potentials     |
!  |  using thermodynamic integration                              |
!  +---------------------------------------------------------------+

   call therm_int 

!  +---------------------------------------------------------------+
!  |  Compute factor involving <V_el0 - V_map>, <V_ii - V_map>,    |
!  |     <V_ff - V_map>                                            |
!  +---------------------------------------------------------------+

   call awarshel_dE

!  +---------------------------------------------------------------+
!  |  Compute PMF aafo an energy gap RC on the EVB ground state    |
!  |  surface, on the V_ii surface, and on the V_ff surface        |
!  +---------------------------------------------------------------+

   call fe_pert

!  +---------------------------------------------------------------+
!  |  Combine the PMF segments using the weighted PMF approach     |
!  +---------------------------------------------------------------+

   call w_pmf

!  +---------------------------------------------------------------+
!  |  Output PMF                                                   |
!  +---------------------------------------------------------------+

   call out_warshel

!  x+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++x
!  x+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++x

   end subroutine awarshel

