! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
! #|  Initialize FE constants for each umbrella window               |#
! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#

   subroutine fngr_init 

   use evb_parm, only: nwin, ndata, beta, umb_sample 

   implicit none


   !  +---------------------------------------------------------------+

   integer :: k

   real*8, intrinsic :: dble, exp


!  +---------------------------------------------------------------+
!  |  Read in F_k                                                  |
!  +---------------------------------------------------------------+

   open( iogr, file = 'f_k.pmf' ) 

   do k = 1, nwin

      read( iogr, * ) kdex, f_k(kdex)

   enddo 

   close( iogr ) 

!  +---------------------------------------------------------------+
!  |  Compute exp( + beta * F_k )                                  |
!  +---------------------------------------------------------------+

   if( lrstart_wham .eq. .true. ) then 

      do k = 1, nwin 

         ebfn(k) = dble( ndata(k) ) * exp( beta * f_k(k) ) 

      enddo 

      print *, 'RESTARTING WHAM FROM F_K.PMF'
      print *, 'K, F_K(K), EBFN(K)'

      do k = 1, nwin

         print *, k, f_k(k), ebfn(k) 

      enddo 
          
   else 

      do k = 1, nwin 

         ebfn(k) = dble( ndata(k) ) * 1.0d0 
        
      enddo 

      print *, 'INITIALIZING F_K = 0 FOR WHAM'

   endif
 
!  x+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++x
!  x+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++x


   end fnrg_init

