! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
! #|  Output mapping potential results and FE profile                |#
! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#

   subroutine out_warshel

   use pmf_parm, only: hits_tol, nwin, num_bin, pmf_unit, rcrd

   use map_pot,  only: map_dat, pmf, wpmf, wpmf_print


   implicit none


   !  +---------------------------------------------------------------+

   integer :: m, n

   real*8, intrinsic :: sum, sqrt

   character(25) :: cwin


!  +---------------------------------------------------------------+
!  |  Output PMF on EVB ground-state surface as a function of      |
!  |  energy gap reaction coordinate                               |
!  +---------------------------------------------------------------+

   do n = 1, nwin

      write( cwin, '(F8.2)') map_dat(n)% lambda(1) 

      print *, 'cwin = ', trim( adjustl(cwin) )

      open( pmf_unit, file = 'AWARSHEL_PMF_EL0_L-'//trim( adjustl(CWIN) ) )

      do m = 1, num_bin

         if( pmf(n)% pb(m) >= hits_tol ) then
 
            write(pmf_unit,1000) rcrd(m), pmf(n)% FE_el0(m)

         endif

      enddo

      close( pmf_unit )

   enddO

!  +---------------------------------------------------------------+
!  |  Output PMF on initial diabatic state surface as a function   |
!  |  of energy gap reaction coordinate                            |
!  +---------------------------------------------------------------+

   do n = 1, nwin

      write( cwin, '(F8.2)') map_dat(n)% lambda(1)

      print *, 'cwin = ', trim( adjustl(cwin) )

      open( pmf_unit, file = 'AWARSHEL_PMF_Vii_L-'//trim( adjustl(CWIN) ) )

      do m = 1, num_bin

         if( pmf(n)% pb(m) >= hits_tol ) then

            write(pmf_unit,1000) rcrd(m), pmf(n)% FE_ids(m)

         endif

      enddo

      close( pmf_unit )

   enddO

!  +---------------------------------------------------------------+
!  |  Output PMF on final diabatic state surface as a function     |
!  |  of energy gap reaction coordinate                            |
!  +---------------------------------------------------------------+

   do n = 1, nwin

      write( cwin, '(F8.2)') map_dat(n)% lambda(1)

      print *, 'cwin = ', trim( adjustl(cwin) )

      open( pmf_unit, file = 'AWARSHEL_PMF_Vff_L-'//trim( adjustl(CWIN) ) )

      do m = 1, num_bin

         if( pmf(n)% pb(m) >= hits_tol ) then

            write(pmf_unit,1000) rcrd(m), pmf(n)% FE_fds(m)

         endif

      enddo

      close( pmf_unit )

   enddo

!  +---------------------------------------------------------------+
!  |  Output weighted-PMF                                          |
!  +---------------------------------------------------------------+

   open( pmf_unit, file = 'AWARSHEL_WPMF' )

   do m = 1, num_bin

      if( wpmf_print(m) /= 0.0d0 ) write(pmf_unit,1000) rcrd(m), wpmf(m)

   enddo

   close( pmf_unit )


 1000 format( 2(2X,F18.4) )

!  +---------------------------------------------------------------+
!  +---------------------------------------------------------------+

   end subroutine out_warshel




