! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
! #|  Output PMF and distributions                                   |#
! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#

   subroutine out_wham 

   use pmf_parm, only: nwin, num_bin, beta_inv, pmf_unit, hits_tol, rcrd

   use wham_umb, only: pb, pub, r0_umb

   implicit none


   !  +---------------------------------------------------------------+

   integer :: j, n

   real*8  :: pmf(num_bin), pmf_biased(num_bin,nwin) 

   real*8  :: pmf_min, pnorm_inv

   character(25) :: fpmf


!  x---------------------------------------------------------------x
!  |  Normalize biased distributions and output                    |
!  x---------------------------------------------------------------x

   PRINT *, 'GENERATING BIASED DISTRIBUTION FUNCTION'

   do j = 1, nwin

      write( fpmf, '(F10.4)' ) r0_umb(j)

      open( pmf_unit, file = 'WHAM_RHO_BIASED_'//trim( adjustl(fpmf) ) ) 

      do n = 1, num_bin

         if( pb(n,j) >= hits_tol ) &
            write( pmf_unit, 1000 )  rcrd(n), pb(n,j)

      enddo 

      close( pmf_unit)

   enddo

!  +---------------------------------------------------------------+
!  |  Output biased PMF                                            |
!  +---------------------------------------------------------------+

   print *, 'beta_inv = ', beta_inv

   pmf_biased(:,:) = 0.0d0

   do j = 1, nwin

      pnorm_inv = 1.0d0 / sum( pb(:,j) )

      print *, j, pnorm_inv

      do n = 1, num_bin

         if( pb(n,j) > 0.0d0 .and. pnorm_inv /= 0.0d0 ) &
            pmf_biased(n,j) = -log( pb(n,j) * pnorm_inv ) * beta_inv  


      enddo

      write( fpmf, '(F10.4)' ) r0_umb(j)

      open( pmf_unit, file = 'WHAM_PMF_BIASED_'//trim( adjustl(fpmf) ) )

      pmf_min = minval( pmf_biased(:,j) )

      print *, 'pmf_min = ', pmf_min

!     pmf_min = 0.0
      do n = 1, num_bin

         if( pb(n,j) >= hits_tol ) &
            write( pmf_unit, * ) rcrd(n), pmf_biased(n,j) - pmf_min

      enddo

      close( pmf_unit )

   enddo 

!  +---------------------------------------------------------------+
!  |  Normalize unbiased distribution & output                     |
!  +---------------------------------------------------------------+

   print *, 'hits_tol = ', hits_tol

   open( pmf_unit, file = 'WHAM_RHO_UNBIASED' )

   do n = 1, num_bin

!     if( pub(n) >= hits_tol ) &
         write( pmf_unit, *)  rcrd(n), pub(n)

   enddo

   close( pmf_unit )

!  +---------------------------------------------------------------+
!  |  Write out QM PMF                                             |
!  +---------------------------------------------------------------+

   pnorm_inv = 1.0d0 / sum( pub(:) )

   pmf(:) = 0.0d0 

   do n = 1, num_bin

      if( pub(n) > 0.0d0 .and. pnorm_inv /= 0.0d0 ) then

         pmf(n) = -log( pub(n) * pnorm_inv ) * beta_inv  

      endif

   enddo

   open ( pmf_unit, file = 'WHAM_PMF_UNBIASED' )

   pmf_min = minval( pmf(:) )

   do n = 1, num_bin

!     if( pub(n) >= hits_tol ) &
         write( pmf_unit, * ) rcrd(n), pmf(n) - pmf_min
            
   enddo

   close( pmf_unit )


 1000 format( 2(2X,F18.4) )

!  x+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++x
!  x+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++x


   end subroutine out_wham

