! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
! #|  Compute optimal biased distribution function                   |#
! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#

   subroutine warshel_pobf 

   use pmf_parm, only: nwin, ndata, bin_width_inv

   use wham_umb, only: ebw, ebfn, pb, pub

   implicit none

   integer :: i, k, l


   !  +---------------------------------------------------------------+


      INTEGER NMAX, MLAMBDA, NUMBIN

      INTEGER NDATA(MLAMBDA)

      REAL*8 POBF(NUMBIN,MLAMBDA), POB(NUMBIN,MLAMBDA)

      REAL*8 EBW(MLAMBDA,NMAX,MLAMBDA), EBFN(MLAMBDA)
     &     , RCRD(NMAX,MLAMBDA), EBF(MLAMBDA)

      REAL*8 BOTTOM, BINSIZE, BINSTART

   integer, intrinsic ::  idint 


!  +---------------------------------------------------------------+
!  |  Compute the optimal biased distribution function             |
!  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!  |  p_k(eta) = exp( - beta * ( W_k(eta) - f_k ) ) * p_0(eta)     |
!  +---------------------------------------------------------------+

   pob (:,:) = 0.0d0 
   pobf(:,:) = 0.0d0 

   do k = 1, nwin 

      do i = 1, nwin 

         do l = 1, ndata(i)

            ibin = idint( ( rcrd(l,i) - bin_start ) * bin_width_inv )

            bottom = 0.0d0 

            do j = 1, nwin

               bottom = bottom + ebw(i,l,j) * ebfn(j) 

            enddo 

            if( bottom /= 0.0d0 ) then 

               pob(ibin,k) = pob(ibin,k) + ebw(i,l,k) * ebf(k) / bottom

               pobf(ibin,k) = pobf(ibin,k) + ebw(i,l,k) / bottom
  
            endif

         enddo 
  
      enddo 

   enddo 

!  x+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++x
!  x+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++x


   end subroutine warshel_pobf

