! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
! #|  Weighted Histogram Analysis Method                             |#
! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#

   subroutine wham 

   implicit none

!  +---------------------------------------------------------------+
!  |  Preprocess umbrella potential data and compute EBW           |
!  +---------------------------------------------------------------+

   print *, 'doing gen_umb_pot'

   call gen_umb_pot

!  +---------------------------------------------------------------+
!  |  Check reconstructed data against those output from Amber     |
!  +---------------------------------------------------------------+

!  call chk_umbdata

!  +---------------------------------------------------------------+
!  |  Prune data                                                   |
!  +---------------------------------------------------------------+

   print *, 'doing prune_umb_pot' 

   call prune_umb_pot

!  +---------------------------------------------------------------+
!  |  Compute free energy constants by iteration                   |
!  +---------------------------------------------------------------+

   print *, 'doing wham_data'

   call wham_data

   print *, 'doing wham_iter'

   call wham_iter_RC

!  +---------------------------------------------------------------+
!  |  Output results from WHAM                                     |
!  +---------------------------------------------------------------+

   print *, 'doing out_wham'

   call out_wham_RC


!  +---------------------------------------------------------------+
!  |  Deallocate memory                                            |
!  +---------------------------------------------------------------+

   call gen_umb_pot_dealloc

   call prune_umb_pot_dealloc

   call wham_data_dealloc

!  x+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++x
!  x+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++x


   end subroutine wham

